#!/bin/bash
#
# Conversor de fitxers PDF a format HTML5
#
# Autor: Joan de Gracia
# Àrea de Cultura Digital - Departament d'Educació
# Llicència GPL 3.0
# Data: 24/07/2021
# Versió: 1.1
#
PDFTOPPM=$(which pdftoppm)
CONVERT=$(which convert)
ZENITY=$(which zenity)
ZIP=$(which zip)
XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
TEMPLATES=/usr/share/linkat/linkat-pdf2html5/templates.tar.gz
DIR_TEMP=$(mktemp -d)
PREFIX="large"
XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
ZIP=$(which zip)
SUFIX="large"
SUFIX_THUMB="thumb"
EXTENSION="jpg"
ARGS_N_CLI="$#"
if [ $ARGS_N_CLI -lt 3 ] && [ $ARGS_N_CLI -ne 0 ]; then
{
	echo "Sense arguments"
	echo "Heu d'introudir els arguments següents:"
	echo "NOM_FITXER NOM_LLIBRE RESOLUCIO_PDF_CONVERTIT"
	exit 0
}
fi
#
# Script:
# Arguments:
#   1r argument: Directori on es troben els fitxers PDF.
#   2n argument: Nom de la unitat.
#   3r argument: Resolució de la imatge. Si no s'especifica-> DEFAULT=300
#
if [ "$ARGS_N_CLI" == "0" ]; then
	FITXER="$($ZENITY --file-selection --file-filter=*.pdf --title="Seleccioneu un fitxer pdf")"
	if [ -z "$FITXER" ]; then
	   $ZENITY --width=300 --info --text "Heu de seleccionar un fitxer. Torneu a executar el programa."
	   exit 0
	fi
else
	FITXER="$1"
fi
if [ "$ARGS_N_CLI" == "0" ];then
	NOM_LLIBRE=$($ZENITY --width=300 --entry \
	--title="Títol de la unitat" \
	--text="Entreu el nom:" \
	--entry-text "PER CANVIAR" )
	NOM_TEMP=$(echo "$NOM_LLIBRE" | tr " " _)
	#NOM_TEMP=$(echo "$NOM_LLIBRE" | tr " " _ | tr -dc '\0-\177')
else
	NOM_LLIBRE="$2"
	NOM_TEMP=$(echo "$NOM_LLIBRE" | tr " " _)
fi
mv "$DIR_TEMP" /tmp/"$NOM_TEMP"
DIR_TEMP=/tmp/"$NOM_TEMP"
BOOK="$DIR_TEMP"/book
PAGES="$DIR_TEMP"/book/pages
#
# ES COPIA L'ORIGINAL PER NO PERDRE'L I PODER GENERAR ELS LLIBRES HTML5 QUE CALGUIN
# A PARTIR DE L'ORIGINAL
cp "$FITXER" "$DIR_TEMP"
#
tar -zxf "$TEMPLATES" --directory="$DIR_TEMP"
cd "$PAGES"
if [ "$ARGS_N_CLI" == "0" ];then
	$ZENITY --width=300 --info --text "Premeu el botó <b>D\'acord</b> per convertir el pdf"
fi
COUNTER=0
#
# RESOLUTION_PDF_CONVERTED (300 DEFAULT)
# CONTROLA LA RESOLUCIÓ QUAN ES FA EL CANVI DE PDF A IMATGE
#
if [ "$ARGS_N_CLI" == "0" ];then
	RESOLUTION_PDF_CONVERTED=$($ZENITY --width=300 --entry \
	--title="Resolució del PDF convertit" \
	--text="Valor:" \
	--entry-text "300" )
	if [ "$RESOLUTION_PDF_CONVERTED" == "" ]; then
	   RESOLUTION_PDF_CONVERTED=300
	fi
else
	RESOLUTION_PDF_CONVERTED="$3" # RESOLUTION_PDF_CONVERTED
#
# Si no es defineix la resolució-> 300 (default)
# El 2n argument especifica la resolució que es farà servir
# per a tots els fitxers.

fi
RESOLUTION=$RESOLUTION_PDF_CONVERTED
RESOLUTION_THUMB=100
if [ "$ARGS_N_CLI" == "0" ];then
	($PDFTOPPM -r $RESOLUTION_PDF_CONVERTED -jpeg "$FITXER" convert
	   for i in $(ls $PAGES); do
	      COUNTER=$((COUNTER+1))
	      mv "$i" "$COUNTER.$EXTENSION"
	      $CONVERT $COUNTER.$EXTENSION -resize $RESOLUTION_THUMB $COUNTER-$SUFIX_THUMB.$EXTENSION
	   done
	) |
	$ZENITY --width=300 --progress \
	   title="Procés de la conversió PDF a HTML" \
	   text="Convertint..." \
	   --auto-close --pulsate
else
	$PDFTOPPM -r $RESOLUTION_PDF_CONVERTED -jpeg "$FITXER" convert
	   for i in $(ls $PAGES); do
	      COUNTER=$((COUNTER+1))
	      mv $i $COUNTER.$EXTENSION
	      $CONVERT $COUNTER.$EXTENSION -resize $RESOLUTION_THUMB $COUNTER-$SUFIX_THUMB.$EXTENSION
	   done
fi
N_PAGES="$(ls $PAGES |grep -i thumb | wc -l)"
sed -i "s/_CADENA_PER_CANVIAR_/$NOM_LLIBRE/g" "$BOOK"/plantilla_index_top.html
sed -i "s/_N_PAGES_/$N_PAGES/g" "$BOOK"/plantilla_index_bottom.html
cd "$BOOK"
cat plantilla_index_top.html  plantilla_index_bottom.html > index.html
rm plantilla_index_top.html  plantilla_index_bottom.html
cd "$DIR_TEMP"
cd /tmp
$ZIP -r "$NOM_TEMP".zip "$NOM_TEMP" >/dev/null 2>&1 
mv "$NOM_TEMP".zip "$ESCRIPTORI"/.
#
# NETEJA EL DIRECTOR TEMPORAL
#
rm -rf "$DIR_TEMP"
if [ "$ARGS_N_CLI" == "0" ]; then
	$ZENITY --width=300 --info --text "Conversió realitzada. \n\n Trobareu el fitxer a l\'escriptori."
fi
