#!/bin/bash
ARGS_N_CLI="$#"
ZENITY="$(which zenity)"
if [ $ARGS_N_CLI -lt 2 ]  && [ $ARGS_N_CLI -ne 0 ]; then
{
	echo "Sense arguments"
	echo "Heu d'introduir els arguments següents:"
	echo "NOM_DIRECTORI_PDFs RESOLUCIO_PDF_CONVERTITS"	
	exit 0
}
fi
if [ "$ARGS_N_CLI" == "0" ]; then
	DIRECTORI_PDF="$($ZENITY --file-selection --title="Seleccioneu un directori que contingui els fitxers PDF a transformar" --directory)"
	if [ -z "$DIRECTORI_PDF" ]; then
	   $ZENITY --width=300 --info --text "Heu de seleccionar un directori. Torneu a executar el programa."
	   exit 0
	fi
else
	DIRECTORI_PDF="$1"
fi
if [ "$ARGS_N_CLI" == "0" ];then
	RESOLUTION_PDF_CONVERTED=$($ZENITY --width=300 --entry \
	--title="Resolució del PDF que s'ha de convertir" \
	--text="Valor:" \
	--entry-text "300" )
	if [ "$RESOLUTION_PDF_CONVERTED" == "" ]; then
	   RESOLUTION_PDF_CONVERTED="300"
	fi
else
	if [[ $2 =~ [^[:digit:]] ]]; then
		RESOLUTION_PDF_CONVERTED="300"
	else
		RESOLUTION_PDF_CONVERTED="$2"
	fi
fi

if [ "$ARGS_N_CLI" == "0" ];then
	$ZENITY --info --width=300 --text "Inici del procés de conversió: $(date +%R:%S)"
	for i in "$DIRECTORI_PDF"/*.{pdf,PDF}
	do
		PDF_FILE="$(echo "$i" | tr -s '/')"
		PDF_NAME="$(echo "$i" | rev | cut -d "/" -f1 |rev)"	
		if [ "$PDF_NAME" != "*.pdf" ] && [ "$PDF_NAME" != "*.PDF" ]; then
			if [ -n "$(file "$PDF_FILE" |grep -i pdf\ document)" ];then
				echo "Processant fitxer $PDF_NAME"
				(bash /usr/share/linkat/linkat-pdf2html5/pdf2flipbook.sh "$PDF_FILE" "$PDF_NAME" "$RESOLUTION_PDF_CONVERTED")|
				$ZENITY --width=300 --progress \
				title="Procés de la conversió PDF a HTML" \
				text="Convertint..." \
				--auto-close --pulsate
			fi
		fi
	done
	$ZENITY --info --width=300 --text "Fi del procés de conversió: $(date +%R:%S)"
else
	echo "Inici del procés de conversió: $(date +%R:%S)"
	echo "###############################"
	for i in "$DIRECTORI_PDF"/*.{pdf,PDF}
	do
		PDF_FILE="$(echo "$i" | tr -s '/')"
		PDF_NAME="$(echo "$i" | rev | cut -d "/" -f1 |rev)"	
		if [ "$PDF_NAME" != "*.pdf" ] && [ "$PDF_NAME" != "*.PDF" ]; then
			if [ -n "$(file "$PDF_FILE" |grep -i pdf\ document)" ];then
				echo "Processant fitxer $PDF_NAME"
				bash /usr/share/linkat/linkat-pdf2html5/pdf2flipbook.sh "$PDF_FILE" "$PDF_NAME" "$RESOLUTION_PDF_CONVERTED"
			fi
		fi
	done
	echo "###############################"
	echo "Fi del procés de conversió: $(date +%R:%S)"
fi
exit 0
