#!/bin/bash
#
# Conversor de fitxers PDF a format HTML
#
# Autor: Joan de Gracia
# Àrea de Cultura Digital - Departament d'Educació
# Llicència GPL 3.0
# Data: 24/07/2021
# Versió: 1.1
#
ZENITY=$(which zenity)
ZIP=$(which zip)
XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
DIR_TEMP=$(mktemp -d)
PDF2HTMLEX=/usr/share/linkat/linkat-pdf2htmlEX/pdf2htmlEX/pdf2htmlEX
FITXER="$($ZENITY --file-selection --file-filter=*.pdf --title="Seleccioneu un fitxer pdf")"
if [ -z "$FITXER" ]; then
   $ZENITY --width=300 --info --text "Heu de seleccionar un fitxer. Torneu a executar el programa."
   exit 0
fi
ZOOM=$($ZENITY --width=300 --entry \
--title="Ampliació:" \
--text="Entreu el valor de l'ampliació.\r\n\n \
El valor 1 manté l'aspecte original.\r\n \
Per utilitzar decimals, fes servir un punt." \
--entry-text "1")
if [ -z "$ZOOM" ]; then
	ZOOM=1
fi
$ZENITY --width=300 --info --text "Premeu el botó <b>D\'acord</b> per convertir el pdf"
cp "$FITXER" "$DIR_TEMP"
cd "$DIR_TEMP" || exit 1
NOM_FITXER="$(ls "$DIR_TEMP")"
($PDF2HTMLEX "$DIR_TEMP/$NOM_FITXER" --zoom "$ZOOM" )| $ZENITY --width=300 --progress \
           title="Procés de la conversió PDF a HTML" \
           text="Convertint..." \
           --auto-close --pulsate
cd "$DIR_TEMP" || exit 1
NOM_TEMP="$(echo "$NOM_FITXER" |cut -d "." -f 1)"
$ZIP -r "$NOM_TEMP"_EX.zip * >/dev/null 2>&1 
mv "$NOM_TEMP"_EX.zip "$ESCRIPTORI"/.
cd || exit 1
cd "$DIR_TEMP" || exit 1
rm *.pdf *.html
cd || exit 1
rmdir "$DIR_TEMP"
$ZENITY --width=300 --info --text "Conversió realitzada. \n\n Trobareu el fitxer a l\'escriptori."


